﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace FileManager
{
    class FileStudioManager
    {
        string pathDes;
        string type;
        string size;
        string dateMody;
        string dateCr;
        string lastAccess;
        string items;
        DirectoryInfo di;
        FileInfo fi;
        DriveInfo dri;
        //*
        public string PathDestription { get { return pathDes; } set { pathDes = value; } }

        public string DateModified
        {
            get
            {
                if (di.Exists)
                {
                    dateMody = di.LastWriteTime.ToString();
                }
                else if (fi.Exists)
                {
                    dateMody = fi.LastWriteTime.ToString();
                }
                else if (dri.IsReady)
                {
                    dateMody = dri.DriveFormat.ToString();
                }
                return dateMody;
            }
        }

        public string Size
        {
            get
            {
                if (di.Exists)
                {
                    size = di.Extension;
                }
                else if (fi.Exists)
                {
                    size = fi.Length.ToString() + " B";
                }
                else if (dri.IsReady)
                {
                    size = dri.TotalSize.ToString();
                }
                return size;
            }
        }

        public string Type 
        {
            get 
            {
                if (di.Exists)
                {
                    type = di.Attributes.ToString();
                }
                else if (fi.Exists)
                {
                    type = fi.Extension;
                }
                else if (dri.IsReady)
                {
                    type = dri.DriveFormat.ToString();
                }
                return type ; 
            } 
        }
        public FileStudioManager(string PathDestription)
        {
            pathDes = PathDestription;
            dri = new DriveInfo(pathDes);
            
            di = new DirectoryInfo(pathDes);
            fi = new FileInfo(pathDes);
        }


    }
}
